define class DMSTreeView as OLEControl
	
	OLEClass     = 'COMCTL.TreeCtrl'
	Name         = 'DMSTreeView'
	
	*---------------------------------------------------------------------------
	* Procedure :  MouseDown
	* Purpose   :  This method will 
	* Programmer:  Russell Campbell
	* Copyright :  The Interthink Consulting Group, Inc. - All Rights Reserved
	* Date      :  02/2000
	* Revisions :
	*---------------------------------------------------------------------------
	procedure MouseDown
	LPARAMETERS button, shift, x, y
		
		local i, ArrayLen, MyDate, oNode, BarNumBeforeDates, ParentPartNum
		local OrigOrder, OrigRecNum
			
		* -------------------------------------------------------------
		* Only do this code if the user pressed the right mouse button.
		* -------------------------------------------------------------
		if Button = 2
			
			* ----------------------------------------------------------
			* Let's go ahead and define our popup, because we are going to 
			* build one whether the user clicked on a node or not.
			* ----------------------------------------------------------
			SET SHADOW ON

			DEFINE POPUP TreePopup ;
			  FROM MROW(), MCOL() ;
			  MARGIN SHORTCUT

			* ----------------------------------------------------------
			* HitTest will return a reference to the node under the mouse.
			* ----------------------------------------------------------
			oNode = This.HitTest(X * Thisform.TreeFactorX, Y * Thisform.TreeFactorX)
			
			if type('oNode') = 'O' and not isnull(oNode)
			
				* -------------------------------------------------------
				* Select the node and execute its NodeClick code.
				* -------------------------------------------------------
				oNode.Selected = .t.
				This.NodeClick(oNode)
				
*				DEFINE BAR  1 OF TreePopup PROMPT ""
*				DEFINE BAR  2 OF TreePopup PROMPT "\-"
				
			endif
			
*			ON SELECTION POPUP TreePopup;
*				_screen.activeform.TreePop(PRMBAR('TreePopup', GETBAR('TreePopup', BAR())))
			
*			ACTIVATE POPUP TreePopup
*			RELEASE POPUP TreePopup
			
		endif

	endproc
	
	*---------------------------------------------------------------------------
	* Method    :  NodeCheck
	* Purpose   :  This method will be executed when the user clicks the checkbox
	*              for a node.
	* Programmer:  Russell Campbell
	* Copyright :  The Interthink Consulting Group, Inc. - All Rights Reserved
	* Date      :  07/01/1998
	* Revisions :
	*---------------------------------------------------------------------------
	procedure NodeCheck
	LPARAMETERS node

		* -------------------------------------------------------------
		* -------------------------------------------------------------
		Node.Selected = .t.
	
	endproc
	
	procedure NodeClick
	LPARAMETERS node
		
		with this
			this.parent.ShowFilesInFolder(.SelectedItem)
			this.parent.TreeViewNodeClick(Node)
		endwith
		
	endproc

	procedure Expand
	LPARAMETERS node
		
		Node.Selected = .T.
		
		this.NodeClick(Node)
		this.parent.AddChildFolders(Node)
		this.parent.TreeViewExpandNode(Node)
		
	endproc

enddefine
