*==============================================================================
* Program:			CreateDesktopShortcut
* Purpose:			Creates a shortcut on the desktop
* Author:			Doug Hennig
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	01/20/2001
* Parameters:		tcLinkFile   - the name of the shortcut file
*					tcFileToLink - the file (including path) the shortcut is
*						for
* Returns:			.T. if the shortcut was created
* Environment in:	the file to link to must exist
* Environment out:	the shortcut was created
*==============================================================================

lparameters tcLinkFile, ;
	tcFileToLink
local lcDesktop, ;
	lcLinkFile

* Find the Desktop folder, then create the shortcut in it.

lcDesktop  = GetDesktopDir()
lcLinkFile = lcDesktop + justfname(tcLinkFile)
return CreateShortcut(lcLinkFile, tcFileToLink)
