*==============================================================================
* Program:			GetAppDir
* Purpose:			Returns the directory the application was started in
* Author:			Doug Hennig, modified from a routine published by Rick
*						Strahl
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	02/08/2001
* Parameters:		tcProgram - the program to get the directory from
*						(optional: if it isn't specified, the top program is
*						used)
* Returns:			the directory with trailing backslash
* Environment in:	none
* Environment out:	none
*==============================================================================

lparameters tcProgram
local lcProgram, ;
	lcPath, ;
	lnBytes, ;
	lcFileName
lcProgram = iif(vartype(tcProgram) = 'C' and not empty(tcProgram), tcProgram, ;
	sys(16, 0))
do case

* In-process DLL server or Active Document.

	case atc('.VFD', lcProgram) > 0 or Application.StartMode = 3
		lcPath = home()

* Out-of-process EXE server.

	case Application.StartMode = 2
		#define MAX_PATH 260
		declare integer GetModuleFileName in Win32API ;
			integer hModule, string @cFileName, integer @nSize
		lnBytes    = MAX_PATH
		lcFileName = space(MAX_PATH)
		GetModuleFileName(0, @lcFilename, @lnBytes)
		lcFileName = left(lcFileName, at(chr(0), lcFilename) - 1)
		lcPath     = justpath(lcFileName)

* Standalone EXE or VFP development.

	otherwise
		lcPath = justpath(lcProgram)
		if atc('PROCEDURE', lcPath) > 0
			lcPath = substr(lcPath, rat(':', lcPath) - 1)
		endif atc('PROCEDURE', lcPath) > 0
endcase
return addbs(upper(lcPath))
